
<template lang="pug">
div
  //- Dialog for adding meeting from zoom account
  q-dialog(
    :value="value",
    @input="$emit('input', $event)",
    @show="getScheduledMeetings"
  )
    q-card(style="width: 98%; max-width: 900px")
      q-card-section.row.items-center
        .text-h6 Select a Meeting
        q-space
        q-btn.q-mr-sm(
          icon="refresh",
          round,
          flat,
          color="primary",
          @click="getScheduledMeetings",
          :loading="zoomLoading && notRequested.length > 0"
        )
        q-input.on-left(
          placeholder="search...",
          outlined,
          rounded,
          dense,
          v-model="searchTerm",
          clearable
        )
        q-btn(icon="close", flat, round, dense, v-close-popup)
      q-separator
      q-banner.bg-yellow-3
        template(v-slot:avatar)
          q-icon(name="info_outline")
        div ZoomSense requires
          strong !{ ' ' } Require Authentication to Join
          | !{ ' ' } to be turned !{ ' ' }
          strong OFF.
          | !{ ' ' }Meeting passwords can still be used.
      q-banner.bg-grey-3(v-if="!groupRecurringMeetings")
        .row.justify-center.items-center
          .col
            div Recurring meetings are currently displayed individually
          .col-auto
            q-btn(flat, dense, @click="groupRecurringMeetings = true") Schedule Together
      q-card-section.scroll(style="max-height: 50vh")
        div(v-if="zoomLoading && notRequested.length == 0")
          .row.justify-center.full-height.full-width.text-center.items-center
            .q-my-xl.q-pa-lg
              p.text-body1 Getting your Zoom schedule...
              q-spinner-dots(color="primary", size="xl")
        .col.q-my-xl.q-pa-xl.text-subtitle1.text-center(
          v-if="!zoomLoading && meetingGroupsForRequesting.length === 0"
        ) You don't have any upcoming Zoom meetings

        q-virtual-scroll(:items="meetingGroupsForRequesting")
          template(v-slot="{ item, index }")
            RequestGroupOfCalls.q-mb-md(
              :calls="item",
              @requestStopGrouping="groupRecurringMeetings = false"
            )
      q-separator
      q-card-actions(align="right")
        q-btn(flat, v-close-popup, @click="manualAdd = true") ADD MEETING MANUALLY

  //-  Dialog to add meeting manually
  q-dialog(v-model="manualAdd")
    q-card(style="width: 500px; max-width: 95%")
      q-form(@submit.prevent.stop="manualschedule")
        q-card-section.row.items-center
          .text-h6 Add ZoomSense Manually
          q-space
          q-btn(icon="close", flat, round, dense, v-close-popup)
        q-separator
        q-banner.bg-yellow-3
          template(v-slot:avatar)
            q-icon(name="info_outline")
          div Please obtain permission from the meeting creator before scheduling ZoomSense.
        q-card-section
          q-input.q-mb-sm(
            v-model="newmeeting.topic",
            label="Name",
            lazy-rules="ondemand",
            :rules="[val => !!val || 'Name is required']",
            outlined
          )
          q-input.q-mb-sm(
            v-model="newmeeting.id",
            label="Zoom Meeting ID",
            lazy-rules="ondemand",
            mask="###########",
            :rules="[val => val.length == 11 || 'Must be a valid Zoom meeting ID']",
            outlined
          )
          q-input.q-mb-lg(
            v-model="newmeeting.password",
            label="Zoom Meeting Password",
            lazy-rules="ondemand",
            outlined
          )
          q-input.q-mb-sm.q-mt-sm(
            outlined,
            v-model="newmeeting.startTimeT",
            :rules="[val => !!val || 'Must be start date and time', val => inFutureDate(val)]",
            label="Start Date & Time",
            lazy-rules="ondemand",
            mask="####-##-## ##:##"
          )
            template(v-slot:prepend)
              q-icon.cursor-pointer(name="event")
                q-popup-proxy
                  q-date(
                    v-model="newmeeting.startTimeT",
                    mask="YYYY-MM-DD HH:mm"
                  )
                    .row.items-center.justify-end
                      q-btn(
                        v-close-popup,
                        label="Close",
                        color="primary",
                        flat
                      )

            template(v-slot:append)
              q-icon.cursor-pointer(name="access_time")
                q-popup-proxy
                  q-time(
                    v-model="newmeeting.startTimeT",
                    mask="YYYY-MM-DD HH:mm",
                    format24h
                  )
                    .row.items-center.justify-end
                      q-btn(
                        v-close-popup,
                        label="Close",
                        color="primary",
                        flat
                      )
          q-input.q-mb-sm(
            v-model="newmeeting.meetingLength",
            label="Meeting Length",
            mask="#:##",
            :rules="[val => !!val || 'Must be a meeting length']",
            lazy-rules="ondemand",
            suffix="h:mm",
            outlined
          )
          q-input(
            lazy-rules="ondemand",
            outlined,
            label="Number of ZoomSensors (Breakout Rooms)",
            type="number",
            min="1",
            max="10",
            :rules="[val => (val > 0 && val < 11) || 'Must be valid number of sensors']",
            v-model="newmeeting.noOfBreakoutRooms"
          )
        q-separator
        q-card-actions(align="right")
          q-btn(type="submit", flat, color="primary") SCHEDULE
        q-card-section.col.text-white.text-center.absolute-top-left.full-height.full-width.bg-positive(
          v-if="isRequestingManual"
        )
          q-spinner-dots.absolute-center(color="white", size="xl")
</template>
<script>
import RequestGroupOfCalls from "./RequestGroupOfCalls.vue";
import { setMeetingScheduleManual } from "../scripts/Meetings";
import { auth } from "../db";
import moment from "moment";
import ErrorHandler from "../mixins/ErrorHandler";

export default {
  props: {
    value: { required: true, type: Boolean },
    // A callback to check if the call is already scheduled
    callAlreadyScheduled: { required: true /* (call) => boolean */ },
  },
  mixins: [ErrorHandler],
  data() {
    return {
      zoomLoading: false,
      manualAdd: false,
      isRequestingManual: false,
      scheduledZoomMeetings: [],
      groupRecurringMeetings: true,
      searchTerm: "",

      newmeeting: {
        topic: "",
        startTime: "",
        password: "",
        noOfBreakoutRooms: 1,
        id: "",
      },
    };
  },
  methods: {
    async getScheduledMeetings() {
      this.zoomLoading = true;

      try {
        const token = await auth.currentUser.getIdToken();
        const resp = await this.$http.post(
          `${process.env.VUE_APP_FB_FUNCTIONS}/getScheduledMeetings`,
          {
            idToken: token,
          },
        );
        this.zoomLoading = false;
        if (resp.status != 200) {
          throw new Error(resp.statusText);
        }
        const userMeetings = resp.data.meetings.meetings;
        const userWebinars = resp.data.webinars.webinars;
        if (userWebinars) {
          userWebinars.forEach(webinar => {
            webinar.type = "webinar";
            const diffInSecs = this.getSecDiff(webinar.start_time);
            if (diffInSecs >= -60 * 60) userMeetings.push(webinar);
          });
        }
        this.scheduledZoomMeetings = userMeetings;
      } catch (error) {
        this.zoomLoading = false;
        this.$cookies.remove("session");
        return new Error(error);
      }
    },
    async manualschedule() {
      this.isRequestingManual = true;

      try {
        let start = moment(this.newmeeting.startTimeT);
        let end = moment(start).add(
          moment.duration(this.newmeeting.meetingLength),
        );
        this.newmeeting.endTime =
          end.utc().format("YYYY-MM-DDTHH:mm:ss.000") + "Z";
        this.newmeeting.startTime =
          start.utc().format("YYYY-MM-DDTHH:mm:ss.000") + "Z";

        await setMeetingScheduleManual(
          this,
          auth.currentUser.uid,
          this.newmeeting,
        );
        this.manualAdd = false;
        this.isRequestingManual = false;
      } catch (err) {
        this.isRequestingManual = false;
        this.showError(err.message);
      }
    },
    inFutureDate(date) {
      return moment(date).isAfter(moment()) || "Must be in the future";
    },
    getSecDiff(startTime) {
      let current = moment().utc().toDate();
      const diffMs = moment(startTime).toDate() - current;
      return diffMs / 1000;
    },
  },
  computed: {
    // ScheduleZoomCalls takes a list of zoom calls to be scheduled,
    // here, we take all `notRequested` zoom calls and group them
    // based on whether the user wants to group recurring meetings
    meetingGroupsForRequesting() {
      const sortedById = [...this.notRequestedSearch].sort(
        (call1, call2) => call1.id - call2.id,
      );

      if (!this.groupRecurringMeetings) {
        return sortedById
          .map(call => [call])
          .sort(
            (group1, group2) =>
              moment(group1[0].startTime) - moment(group2[0].startTime),
          );
      }

      // The calls, grouped
      // A list of lists of calls
      const groups = [];

      // Here, we build out the groups
      let currentGroup = [];
      let currentGroupsId = "";
      sortedById.forEach(call => {
        if (call.id !== currentGroupsId) {
          if (currentGroup.length > 0) {
            groups.push(currentGroup);
          }
          currentGroup = [call];
          currentGroupsId = call.id;
        } else {
          currentGroup.push(call);
        }
      });
      if (currentGroup.length > 0) groups.push(currentGroup);
      return groups.sort(
        (group1, group2) =>
          moment(group1[0].startTime) - moment(group2[0].startTime),
      );
    },
    notRequestedSearch() {
      return this.notRequested.filter(m =>
        m.topic
          .toLowerCase()
          .includes(
            this.searchTerm == null ? "" : this.searchTerm.toLowerCase(),
          ),
      );
    },
    notRequested() {
      return this.scheduledZoomMeetings
        .filter(call => {
          return (
            call.start_time !== undefined && !this.callAlreadyScheduled(call)
          );
        })
        .map(meeting => ({
          topic: meeting.topic,
          id: meeting.id,
          startTime: moment(meeting.start_time).toISOString(),
          endTime: moment(meeting.start_time)
            .add(meeting.duration, "minutes")
            .toISOString(),
          requested: false,
          type: meeting.type,
        }))
        .sort((a, b) => moment(a.startTime) - moment(b.startTime));
    },
  },
  components: {
    RequestGroupOfCalls,
  },
};
</script>
